/*  gp2xpectrum  for GP2X

    Copyright (C) 2006-2008 Metalbrain, Seleuco
    Copyright (C) 2006  Hermes/PS2Reality  * Made in Vallecas - Madrid (Spain)

    Copyright (C) 2004  rlyeh (fZX32 for GP32)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <sdl.h>
#include <sys\time.h>

//#define DEBUG_MSG 
#define USE_ZIP
//#define CAPTURE

#ifdef USE_ZIP
#include "zip.h"
#endif

#include "bzip/bzlib.h"
#include "microlib.h"

//#include "zx.h"
//#include "z80.h"
//#include "fdc.h"
#include "empty_dsk.h"
#include "shared.h"
#include "usbkeymap.h"

long cur_frame;

extern Z80Regs * spectrumZ80;
extern void Sound_Loop();
extern int full_screen;
extern char rompath[247];
char * get_name(char *name);
unsigned char COLORFONDO=0; // color de fondo (vaya noticia :P)
extern byte  DSK[1*1024*1024]; 
extern t_drive driveA;
extern t_FDC FDC;
extern t_track *active_track;

unsigned gp2x_nKeys=0;
int emu_running = 0;
void write_keyfile(char *name);
void read_keyfile(char *name);

char * MY_filename="default_name.fk";
#ifdef UIQ3
char globalpath[247]="c:/shared/gp2xpectrum";
#else
char globalpath[247]="c:/data/gp2xpectrum";
#endif
char pathstring[247];
char pathstring2[247];
char pathstring3[247];
int volume=50;
int delayvalue=0;

int init_speed_loading=0;
MCONFIG mconfig;


//int delay_volume=0;

//int auto_fire=0;
int dsk_flipped=0;
int load_state(int st);
int save_state(int st);
int dsk_save (char *pchFileName/*, t_drive *drive, char chID*/);
int dsk_format ();
int lim_time;
int i=0;

int target_fps, target_frametime;
int thissec = 0, frames_done = 0, frames_shown = 0, frames_rendered = 0;

int reset_timing = 1;
struct timeval tval; // timing
/*********************************************************************/
/* GP2X System                                                       */
/*********************************************************************/
void ClearScreen(unsigned char c) // se usa para 'borrar' la pantalla virtual con un color
{
int n;

for(n=0;n<320*240;n++)
	{
	gp2x_screen[n]=c;
	}	
}

void SetVideoScaling(int pixels,int width,int height)
{
static int pixels2=0,width2=0,height2=0;
if(width2!=width || height2!=height)
	{    
	width2=width;height2=height;
	ClearScreen(COLORFONDO);
	gp2x_set_scaling(width,height);
	}
if(pixels2!=pixels)
    {
	pixels2=pixels;
	
	}

}

/*********************************************************************/
/* Save/Load configuration of gp2xpectrum                             */
/*********************************************************************/

void load_mconfig()
{
	FILE *fp;
	int factor;
	int read=0;
	sprintf(pathstring,"%s/saves/gp2xpectrum.cfg",globalpath);
	fp=fopen(pathstring,"rb");

if(fp!=NULL)
	{ 	   
	fread(&mconfig, 1, sizeof(mconfig), fp);
	fclose(fp);
	read=1;
	}
if(mconfig.id!=0xABCD0013 || !read)
	{
	mconfig.id=0xABCD0013;
    	mconfig.zx_screen_mode=0;//lo pongo en no full yo por defecto. OK MetalBrain
    	mconfig.battery_icon=0	;//le quito yo por defecto el icono de la bateria
    	mconfig.frameskip=-1;//le pongo por defecto el frameskip a cero
    	mconfig.contention=1;
    	mconfig.sound_volume=50;    	
    	mconfig.sound_gain=1;//Medium    	
    	mconfig.sound_mode=1;//Mono
    	mconfig.sound_freq=44100;//44100
    	mconfig.speed_mode=100;//100% emulation    	
    	mconfig.show_fps=0;
    	mconfig.speed_loading=1;
    	mconfig.flash_loading=1;
    	mconfig.edge_loading=1;
    	mconfig.auto_loading=1;
	}
else
	{
	strcpy(rompath, mconfig.rom_path);
	}

volume = mconfig.sound_volume;
factor = (20 * 100 ) / mconfig.speed_mode;

delayvalue= factor;
target_frametime = delayvalue*1000;
}

void save_mconfig()
{
FILE *fp;

mconfig.sound_volume=volume;
strcpy(mconfig.rom_path, rompath);
sprintf(pathstring,"%s/saves/gp2xpectrum.cfg",globalpath);
fp=fopen(pathstring,"wb");
if(fp==NULL) return;
fwrite(&mconfig, 1, sizeof(mconfig), fp);
fclose(fp);
}




/****************************************************************************************************************************************/
// PANTALLA
/****************************************************************************************************************************************/


void speccy_corner()
{
int x1=320-1,y1=240-64,x;
int n,m;
unsigned char *p;
for(n=0;n<32;n++)
	{
	if(y1>=240) break;
	p=&gp2x_screen[x1+y1*320];
	x=x1;
	for (m=0;m<6;m++,x++) {if(x<320) {p[320]=3;*p++=3;}} // rojo
	for (m=0;m<6;m++,x++) {if(x<320) {p[320]=4;*p++=4;}} // amarillo
	for (m=0;m<6;m++,x++) {if(x<320) {p[320]=1;*p++=1;}} // verde
	for (m=0;m<6;m++,x++) {if(x<320) {p[320]=5;*p++=5;}} // cyan
	y1+=2;
	x1--;
	}
}
extern unsigned char msx[];  // define la fuente externa usada para dibujar letras y numeros 

unsigned char mypalette_rgb[7][3]={
{0x00,0x40,0x00},
{0x00,0xff,0x00},
{0xff,0xff,0xff},
{0xff,0x00,0x00},
{0xff,0xff,0x00},
{0x00,0xff,0xff},
{0x00,0x00,0x00},
};
int is_my_palette=1;

void set_mypalette()
{
int n;
for(n=0;n<7;n++)
gp2x_set_palette_color(mypalette_rgb[n][0],mypalette_rgb[n][1],mypalette_rgb[n][2],n);

gp2x_set_palette_color(255,255,255,255);
gp2x_set_palette();
is_my_palette=1;

}

void set_emupalette()
{
int i;
unsigned char r,g,b;

//unsigned  ga=(unsigned) (255.0*((float) (1024+170*(mconfig.bright & 3)))/1024.0);



  for(i=0;i<17;i++)
   {
   
    
     r=zx_colours[i][0];
     g=zx_colours[i][1];
     b=zx_colours[i][2];

     
    gp2x_set_palette_color(r,g,b,i);
	gp2x_set_palette_color(r>>1,(g>>2) | 64,b>>1,i+18);
   }
gp2x_set_palette_color(0,255,0,252);
gp2x_set_palette_color(255,0,0,253);
gp2x_set_palette_color(255,255,0,254);
gp2x_set_palette_color(255,255,255,255);
gp2x_set_palette();

is_my_palette=0;

}


void v_putchar( unsigned x, unsigned y, unsigned char color, unsigned char ch) // rutina usada para dibujar caracteres (coordenadas de 8x8)
{
   volatile int 	i,j;
   volatile unsigned char	*font;
  volatile unsigned char col,col2;
  volatile unsigned char *p;
   if(x>=40 || y>=30) return;

  

col=color;
col2=COLORFONDO;

  
   font = &msx[ (int)ch * 8];
   p=&gp2x_screen[(y*320*8)+(x<<3)];
   if(col!=col2)
   {
   for (i=0; i < 8; i++, font++)
		{  
		 for (j=0; j < 8; j++)
          {
          if ((*font & (128 >> j))) p[j]=col;
			  
			else  p[j]=col2;
          }
	  p+=320;
	 }
   }
   else
   {
   for (i=0; i < 8; i++, font++)
		{  
		 for (j=0; j < 8; j++)
          {
          if ((*font & (128 >> j))) p[j]=col;
			  
          }
	  p+=320;
	 }
   }
}

// display array of chars

int v_breakcad=40;
int v_forcebreakcad=0;
int lastx=0;
void v_putcad(int x,int y,unsigned color,char *cad)  // dibuja una cadena de texto
{
int n=0;	
while(cad[0]!=0) {if(n==v_breakcad) break; v_putchar(x,y,color,cad[0]);cad++;x++;n++;}
if(v_forcebreakcad)
	{
	while(1) {if(x>=40 || n==v_breakcad) break; v_putchar(x,y,color,' ');cad++;x++;n++;}
	}
lastx=x;
}

unsigned char mask_keyb[32*8*11*8];

void mask_putchar( unsigned x, unsigned y, unsigned char color, unsigned char ch) // rutina usada para dibujar caracteres (coordenadas de 8x8)
{
  volatile  int 	i,j;
   volatile unsigned char	*font;
  unsigned char col,col2;
    volatile unsigned char *p;
   if(x>=36 || y>=20) return;
x-=4;
y-=9;

col=color;
col2=COLORFONDO;


   font = &msx[ (int)ch * 8];
   p=&mask_keyb[(y*32*8*8)+(x<<3)];
   if(col!=col2) 
   {
   for (i=0; i < 8; i++, font++)
		{  
		 for (j=0; j < 8; j++)
          {
          if ((*font & (128 >> j)))  p[j]=col;
			else p[j]=col2;
          }
	  p+=32*8;
	 }
   }
   else
   {
   for (i=0; i < 8; i++, font++)
		{  
		 for (j=0; j < 8; j++)
          {
          if ((*font & (128 >> j)))  p[j]=col;

          }
	  p+=32*8;
	 }
   }
 
}


void mask_out(int  x,int y)
{
int   n,m;
volatile unsigned char *p,*p2,v;
for(n=0;n<11*8;n++)
	{
	p=&gp2x_screen[(y+n)*320+x];
	p2=&mask_keyb[n*32*8];
	for(m=0;m<32*8;m++)
		{
		if(*p2==0)
		{
		v=*p;if(v<17) v+=18;*p++=v;p2++;
		}
		else *p++=*p2++;
		
		
		}
	}
}


int mask_chars=0;

void mask_putcad(int x,int y,unsigned color,char *cad)  // dibuja una cadena de texto
{
int n=0;	
while(cad[0]!=0) {if(n==v_breakcad) break; if(mask_chars) mask_putchar(x,y,color,' '); else mask_putchar(x,y,color,cad[0]);cad++;x++;n++;}
if(v_forcebreakcad)
	{
	while(1) {if(x>=40 || n==v_breakcad) break; mask_putchar(x,y,color,' ');cad++;x++;n++;}
	}
lastx=x;
}

/*********************************************************************/
//  saving bitmap (photo mode)
/*********************************************************************/

int make_photo=0; // variable asignada cuando queremos hacer una foto

int photo_number=0;  // contador de numero de foto
char photo_name[256]; // nombre del fichero

typedef struct{
	
	 
	unsigned size;
	unsigned reserved; 
	unsigned offset; 

	unsigned header_size; 
	unsigned width ; 
	unsigned height; 
	unsigned short planes;  
	unsigned short bpp; 
	unsigned compression; 
	unsigned image_size; 
	unsigned ppm[2]; 
	unsigned color_info[2]; 

} bmp_header;
bmp_header bmph;

struct 
{
unsigned char b,g,r,a;
} prgba;

void save_bmp(char *name,unsigned char *punt, int ancho, int alto, int align)
{
FILE *fp;
int i,n;
fp=fopen(name,"wb");
if(fp==NULL) return;
fputc('B',fp);
fputc('M',fp);
bmph.reserved=0;
bmph.size=54+ancho*alto+256*4;
bmph.offset=256*4+54;
bmph.header_size=40;
bmph.width=ancho;
bmph.height=alto;
bmph.planes=1;
bmph.bpp=8;
bmph.compression=0;
bmph.image_size=ancho*alto;
bmph.ppm[0]=bmph.ppm[1]=0;
bmph.color_info[0]=0; // 0 es 256
bmph.color_info[1]=0;
fwrite(&bmph, 1, 52, fp);
prgba.a=0;
for(i=0;i<256;i++)
  {
  if(is_my_palette && i<7)
	  {
	  prgba.r=mypalette_rgb[i][0];
	  prgba.g=mypalette_rgb[i][1];
	  prgba.b=mypalette_rgb[i][2];
      }
 else
  if(i<17)
	  {
      prgba.r=zx_colours[i][0];
      prgba.g=zx_colours[i][1];
      prgba.b=zx_colours[i][2];
	  }
  else 
	 if(i<34)
	  {
	  n=i-18;
      prgba.r=zx_colours[n][0]>>1;
      prgba.g=(zx_colours[n][1]>>2) | 64;
      prgba.b=zx_colours[n][2]>>1;
	  }
  else
  if(i==252)
	  {
	  prgba.r=0;
      prgba.g=255;
      prgba.b=0;
	  }
  else
  if(i==253)
	  {
	  prgba.r=255;
      prgba.g=0;
      prgba.b=0;
	  }
  else
  if(i==254)
	  {
	  prgba.r=255;
      prgba.g=255;
      prgba.b=0;
	  }
  else
  if(i==255)
	  {
	  prgba.r=255;
      prgba.g=255;
      prgba.b=255;
	  }
  else
	  {
	  prgba.r=((i&0x1c)<<3);
      prgba.g=(((i&0xe0)>>2)<<2);
      prgba.b=(((i&3)<<6));
	  }
  fwrite(&prgba, 1, 4, fp);
  }

for(i=1;i<=alto;i++)
	{
	fwrite(punt+(alto-i)*align, 1, ancho, fp);
	}
fclose(fp);
}



/***************************************************************************/
// seleccion de roms y otras pantallas del emu 
/***************************************************************************/


#define MAX_ENTRY 10240

char files[MAX_ENTRY][257];
int nfiles=0;

int is_ext(const char *a,char *b) // compara extensiones
{
int n,m;
m=0;n=0;

while(a[n]!=0) {if(a[n]=='.') m=n; n++;}
n=0;
while(b[n]!=0) {if(tolower(a[m])!=tolower(b[n])) return 0; m++; n++;}
if(a[m]==0) return 1;
return 0;
}
/*************************************************************************************************************************/
//
// SPECTRUM interface
//
//
/**************************************************************************************************************************/

// spectrum
unsigned new_key=0,old_key=0;

unsigned char * Picture;
unsigned char *LCDs8;
void msg(char *s)
{
 /*DrawMessageC(s);
 FlipScreen(1,0);
 DrawMessageC(s);
 FlipScreen(1,0);
 DrawMessageC(s);
 FlipScreen(1,0);
 while(!GpKeyGet()); while(GpKeyGet());*/

}

int keyb_num[4][10]={

	{SPECKEY_1, SPECKEY_2, SPECKEY_3, SPECKEY_4, SPECKEY_5,SPECKEY_6, SPECKEY_7, SPECKEY_8, SPECKEY_9, SPECKEY_0},
	{SPECKEY_Q,SPECKEY_W,SPECKEY_E,SPECKEY_R, SPECKEY_T,SPECKEY_Y,SPECKEY_U,SPECKEY_I,SPECKEY_O, SPECKEY_P},
	{SPECKEY_A,SPECKEY_S,SPECKEY_D, SPECKEY_F, SPECKEY_G, SPECKEY_H,SPECKEY_J, SPECKEY_K, SPECKEY_L,SPECKEY_ENTER},
	{SPECKEY_SHIFT,SPECKEY_Z,SPECKEY_X, SPECKEY_C, SPECKEY_V,SPECKEY_B, SPECKEY_N, SPECKEY_M, SPECKEY_SYMB,SPECKEY_SPACE}
};    

char keyb_str[8][10][4]={
	{" 1 "," 2 "," 3 "," 4 "," 5 "," 6 "," 7 "," 8 "," 9 "," 0 "},
	{" Q "," W "," E "," R "," T "," Y "," U "," I "," O "," P "},
	{" A "," S "," D "," F "," G "," H "," J "," K "," L ","ENT"},
	{"CAP"," Z "," X "," C "," V "," B "," N "," M ","SYM","SPC"},
	{" ! "," @ "," # "," $ "," % "," & "," ' "," ( "," ) "," _ "},
	{" <="," <>"," >="," < "," > "," &&"," ||"," at"," ; "," \42 "},
	{" sp"," no"," st"," to"," th"," ^ "," - "," + "," = ","ENT"},
	{"CAP","  :","  l"," ? "," / "," * "," , "," . ","SYM","SPC"}
};


/*
fill_mask(int  x,int  y,int anc,int  alt)
{
int   n,m;
volatile unsigned char *p,v;
for(n=0;n<alt;n++)
	{
	p=&gp2x_screen8[(y+n)*320+x];
	for(m=0;m<anc;m++)
		{
		v=*p;if(v<17) v+=18;*p++=v;
		
		}
	}
}
*/
int keyboard_on=0;
int keyboard_press=0;
int autoload=0;
int mJoystick =1;//DAV: cambio defecto a kemston
				//left/right/up/down/a,b,x,y/L/R
int map_keys[14]={SPECKEY_O,SPECKEY_P,SPECKEY_Q,SPECKEY_A,SPECKEY_SPACE,SPECKEY_M,SPECKEY_ENTER,SPECKEY_0,SPECKEY_SHIFT,SPECKEY_SYMB,SDLK_SPACE,SDLK_PERIOD,SDLK_ESCAPE,SDLK_RETURN};

int multiple_key[10]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};

/****************************************************************************************************************/
// POKE MANAGER
/****************************************************************************************************************/

void write_keyfile(char *name)
{
FILE *fp;
fp=fopen(name,"w");
if(fp==0) return;
fprintf(fp,"mJoystick: %i\n",mJoystick);
fprintf(fp,"LEFT: %i\n",map_keys[0]);
fprintf(fp,"RIGHT: %i\n",map_keys[1]);
fprintf(fp,"UP: %i\n",map_keys[2]);
fprintf(fp,"DOWN: %i\n",map_keys[3]);
fprintf(fp,"A: %i\n",map_keys[4]);
fprintf(fp,"B: %i\n",map_keys[5]);
fprintf(fp,"X: %i\n",map_keys[6]);
fprintf(fp,"Y: %i\n",map_keys[7]);
fprintf(fp,"L: %i\n",map_keys[8]);
fprintf(fp,"R: %i\n",map_keys[9]);
fprintf(fp,"FIRE: %i\n",map_keys[10]);
fprintf(fp,"VKB: %i\n",map_keys[11]);
fprintf(fp,"MENU: %i\n",map_keys[12]);
fprintf(fp,"ACTION: %i\n",map_keys[13]);
fclose(fp);
}

void read_keyfile(char *name)
{
FILE *fp;
int mode=0;
int n=0,m=0;

default_pokes();

fp=fopen(name,"r");
if(fp==0) return;

if(fscanf(fp,"mJoystick: %i\n",&m)==1) mJoystick=m;
if(fscanf(fp,"LEFT: %i\n",&m)==1) map_keys[0]=m;
if(fscanf(fp,"RIGHT: %i\n",&m)==1) map_keys[1]=m;
if(fscanf(fp,"UP: %i\n",&m)==1) map_keys[2]=m;
if(fscanf(fp,"DOWN: %i\n",&m)==1) map_keys[3]=m;
if(fscanf(fp,"A: %i\n",&m)==1) map_keys[4]=m;
if(fscanf(fp,"B: %i\n",&m)==1) map_keys[5]=m;
if(fscanf(fp,"X: %i\n",&m)==1) map_keys[6]=m;
if(fscanf(fp,"Y: %i\n",&m)==1) map_keys[7]=m;
if(fscanf(fp,"L: %i\n",&m)==1) map_keys[8]=m;
  else map_keys[8]=SPECKEY_SHIFT;
if(fscanf(fp,"R: %i\n",&m)==1) map_keys[9]=m;
  else map_keys[9]=SPECKEY_SYMB;
if(fscanf(fp,"FIRE: %i\n",&m)==1) map_keys[10]=m;
  else map_keys[10]=SDLK_SPACE;
if(fscanf(fp,"VKB: %i\n",&m)==1) map_keys[11]=m;
  else map_keys[11]=SDLK_PERIOD;
if(fscanf(fp,"MENU: %i\n",&m)==1) map_keys[12]=m;
  else map_keys[12]=SDLK_ESCAPE;
if(fscanf(fp,"ACTION: %i\n",&m)==1) map_keys[13]=m;
  else map_keys[13]=SDLK_RETURN;
fclose(fp);
}

int program_mode=0;
int key_to_map = -1;
static int unprogram=0;
static int menu_mode=0;


static int redrawmask=1;
int display_keyboard()
{
int n,m,ret;
static int curx=0;
static int cury=0;
static int f1=0,f2=0,f3=0,f4=0;
static int sub_men=0;
static int flip=0;

if(menu_mode==0)
{
if(program_mode && cury<4)
	{
	 if((new_key & GP2X_LEFT))  {map_keys[0]=keyb_num[cury][curx];program_mode=0;redrawmask=1;key_to_map = -1;return -1;}
	 if((new_key & GP2X_RIGHT)) {map_keys[1]=keyb_num[cury][curx];program_mode=0;redrawmask=1;key_to_map = -1;return -1;}
	 if((new_key & GP2X_UP))    {map_keys[2]=keyb_num[cury][curx];program_mode=0;redrawmask=1;key_to_map = -1;return -1;}
	 if((new_key & GP2X_DOWN))  {map_keys[3]=keyb_num[cury][curx];program_mode=0;redrawmask=1;key_to_map = -1;return -1;}
	 if((new_key & GP2X_A))     {map_keys[4]=keyb_num[cury][curx];program_mode=0;redrawmask=1;key_to_map = -1;return -1;}
	 //if((new_key & GP2X_B))     {map_keys[5]=keyb_num[cury][curx];program_mode=0;redrawmask=1;key_to_map = -1;return -1;}
	 
	 /*if((new_key & GP2X_X))     {map_keys[6]=keyb_num[cury][curx];program_mode=0;redrawmask=1;return -1;}
	 if((new_key & GP2X_Y))     {map_keys[7]=keyb_num[cury][curx];program_mode=0;unprogram=40;redrawmask=1;return -1;}*/
	 //if((new_key & GP2X_L))     {map_keys[8]=keyb_num[cury][curx];program_mode=0;redrawmask=1;return -1;}
	 //if((new_key & GP2X_R))     {map_keys[9]=keyb_num[cury][curx];program_mode=0;redrawmask=1;return -1;}
	}

if(!program_mode)
	{
	if(old_key  & GP2X_UP)
		{
		if(f1==0) f1=1;
		else {f1++;if(f1>20) {f1=17;new_key|=GP2X_UP;}}
		} else f1=0;

	if(old_key  & GP2X_DOWN)
		{
		if(f2==0) f2=1;
		else {f2++;if(f2>20) {f2=17;new_key|=GP2X_DOWN;}}
		} else f2=0;

	if(old_key  & GP2X_LEFT)
		{
		if(f3==0) f3=1;
		else {f3++;if(f3>20) {f3=17;new_key|=GP2X_LEFT;}}
		} else f3=0;

	if(old_key  & GP2X_RIGHT)
		{
		if(f4==0) f4=1;
		else {f4++;if(f4>20) {f4=17;new_key|=GP2X_RIGHT;}}
		} else f4=0;		

	if(new_key & GP2X_UP) {redrawmask=1;cury--;if(cury<0) cury=4;if(cury==4) if(curx>4)  curx=4;}
	if(new_key & GP2X_DOWN) {redrawmask=1;cury++;if(cury>4) cury=0;if(cury==4) if(curx>4)  curx=4;}
	if(new_key & GP2X_LEFT) {redrawmask=1;curx--;if(curx<0) curx=9;if(cury==4) if(curx>4)  curx=4;}
	if(new_key & GP2X_RIGHT) {redrawmask=1;curx++;if(curx>9) curx=0;if(cury==4) if(curx>4)  curx=0;}

	if((new_key & GP2X_A) && cury<4)
		{
		for(n=0;n<8;n++)
			if(multiple_key[n]==-1) {multiple_key[n]=keyb_num[cury][curx];break;}
		}
#pragma message("Release multiple keys")
	/*
	if(old_key & GP2X_B)
		{for(n=0;n<8;n++)
			if(multiple_key[n]!=-1) ZXKey(multiple_key[n]);
		}*/

	}

if((new_key & GP2X_SELECT) && cury!=4) 
	{
	redrawmask=1;program_mode^=1;
	if(program_mode)
		{
		key_to_map = keyb_num[cury][curx];
		}
	else
		{
		key_to_map = -1;
		}
		
	}

if(program_mode) 
	redrawmask=1;
else
	{
    if(old_key & GP2X_L) {redrawmask=1;}
	if(old_key & GP2X_R) {redrawmask=1;}
	}
if(redrawmask)
	{
	memset(&mask_keyb[0],0,32*8*11*8);
	for(n=0;n<4;n++)
	for(m=0;m<10;m++)
	{
	if(program_mode) 
		{
		if(curx==m && cury==n) {if(flip & 2) COLORFONDO=252; else COLORFONDO=255;} else COLORFONDO=255;
		}
	else 
		{if(curx==m && cury==n) COLORFONDO=252; else COLORFONDO=255;
		if(n==3 && m==0 && (old_key & GP2X_L)) {redrawmask=1;COLORFONDO=254;}
		if(n==3 && m==8 && (old_key & GP2X_R)) {redrawmask=1;COLORFONDO=254;}
		}
	if(n==3 && m==9) {COLORFONDO=252+(COLORFONDO==255);mask_putcad(5+m*3,n*2+10,253,&keyb_str[n][m][0]);}
	else 
		{
		mask_putcad(5+m*3,n*2+10,255,&keyb_str[n+4*((old_key & GP2X_R)!=0)][m][0]);
		}
	}
	if(curx==0 && cury==n) COLORFONDO=252; else COLORFONDO=255;
	mask_putcad(5,n*2+10,255,"RESET ");
	
	
	if(curx==1 && cury==n) COLORFONDO=252; else COLORFONDO=255;
	mask_putcad(lastx,n*2+10,255,"LOAD ");
	
	
	if(curx==2 && cury==n) COLORFONDO=252; else COLORFONDO=255;
	
	if(mJoystick==1) mask_putcad(lastx,n*2+10,255,"KEMPSTON ");
	if(mJoystick==2) mask_putcad(lastx,n*2+10,255,"INTERFII ");
	if(mJoystick==3) mask_putcad(lastx,n*2+10,255,"INTERF I ");
	if(mJoystick==4) mask_putcad(lastx,n*2+10,255,"CURSOR ");
	if(mJoystick==5) mask_putcad(lastx,n*2+10,255,"FULLER ");
	if(mJoystick==0) mask_putcad(lastx,n*2+10,255,"KEYBOARD ");

	if(curx==3 && cury==n) COLORFONDO=252; else COLORFONDO=255;
	mask_putcad(lastx,n*2+10,255,"MKEY ");

	if(curx==4 && cury==n) COLORFONDO=252; else COLORFONDO=255;
	mask_putcad(lastx,n*2+10,255,"TAPE ");	
	
	redrawmask=0;
	}// redraw

if(!program_mode) 
	{
    if(old_key & GP2X_L) {redrawmask=1;}
	if(old_key & GP2X_R) {redrawmask=1;}
	}

mask_out(4*8,9*8);
//fill_mask(4*8,9*8,32*8,11*8);

flip++;	
COLORFONDO=0;
if(cury==4 && !program_mode && !menu_mode) 
	{
	if(new_key & (GP2X_X))
		{program_mode=0;redrawmask=1;
		if(curx==0) {sub_men=0;menu_mode=1;} //ZX_Reset(ZX_48);
		if(curx==1) autoload=1;
		if(curx==2) {mJoystick++;if(mJoystick>5) mJoystick=0;}
		if(curx==3) {for(n=0;n<8;n++)
		             if(multiple_key[n]!=-1) ZXKey(multiple_key[n]);
			        multiple_key[0]=multiple_key[1]=multiple_key[2]=multiple_key[3]=
					multiple_key[4]=multiple_key[5]=multiple_key[6]=multiple_key[7]=-1;
                    return -1;
					}
		
		if(curx==4) {            
            set_mypalette();

			tape_browser();while(gp2x_nKeys & (GP2X_SELECT)) gp2x_nKeys=gp2x_joystick_poll();keyboard_on=0;
			
			set_emupalette();
            gp2x_flip(); 
            COLORFONDO=0;
            ClearScreen(COLORFONDO);gp2x_waitvsync();			
			
			}
		}
	return -1;
	}
}
if(menu_mode==1)
	{

	//fill_mask(4*8,9*8,32*8,11*8);
	if(redrawmask)
	{
	memset(&mask_keyb[0],0,32*8*11*8);
	COLORFONDO=254;
     	mask_putcad(7,12,254,"SELECT SPECTRUM EMULATION");
	if(sub_men==0) COLORFONDO=252; else COLORFONDO=255;
	mask_putcad(6,14,255,"48K ");
	if(sub_men==1) COLORFONDO=252; else COLORFONDO=255;
	mask_putcad(lastx,14,255,"128K ");
	if(sub_men==2) COLORFONDO=252; else COLORFONDO=255;
	mask_putcad(lastx,14,255,"PLUS2 ");
	if(sub_men==3) COLORFONDO=252; else COLORFONDO=255;
	mask_putcad(lastx,14,255,"PLUS2A ");
	if(sub_men==4) COLORFONDO=252; else COLORFONDO=255;
	mask_putcad(lastx,14,255,"PLUS3");
	redrawmask=0;
	}// redraw

mask_out(4*8,9*8);

	if(new_key & GP2X_LEFT) {redrawmask=1;sub_men--;if(sub_men<0) sub_men=4;}
	if(new_key & GP2X_RIGHT) {redrawmask=1;sub_men++;if(sub_men>4) sub_men=0;}
	if(new_key & GP2X_SELECT) {redrawmask=1;menu_mode=0;}
	if(new_key & (GP2X_X))
	{redrawmask=1;
	switch(sub_men)
		{
		case 1:ZX_Reset(ZX_128);break;
		case 2:ZX_Reset(ZX_PLUS2);break;
		case 3:ZX_Reset(ZX_PLUS2A);break;
		case 4:ZX_Reset(ZX_PLUS3);dsk_load((void *) DSK);break;
		default:ZX_Reset(ZX_48);break;
		}
	menu_mode=0;
	}
	return -1;
	}

ret=keyb_num[cury][curx];
return ret;
}


#ifdef USE_ZIP

char *zip_files[MAX_ENTRY];
int  zip_pos_file[MAX_ENTRY];

int zip_load(char *name)
{
 struct zip *za;
 struct zip_file * fp;
 struct zip_stat st;

 int n,m,idx;
 int err;
char cad[256];  
 int  zip_num_files = 0;
 int y = 0;
int posfile=0;
unsigned new_key=0,old_key=0;
int f=0;

if ((za=zip_open(name, 0, &err)) == NULL)     return -1;
 m= zip_get_num_files(za);
 if(m<=0) {zip_close(za);return -2;}
 
 
////seleccionar

 for(idx=0;idx<m/*,zip_num_files<MAX_ENTRY*/;idx++)
 {
	zip_stat_index(za, idx , 0, &st);
	if(( 
	is_ext(st.name,".z80") ||
			is_ext(st.name,".sna") ||
			is_ext(st.name,".tzx") || 
			is_ext(st.name,".tap") ||
			is_ext(st.name,".sp") ||
			is_ext(st.name,".dsk")
			
	 )) 
	 {
	    zip_files[zip_num_files] = (char *)st.name;
	    //zip_files[zip_num_files]="kk";
	    zip_pos_file[zip_num_files] = idx;
	    zip_num_files++;
	   
	    //strcpy(&zip_files[zip_num_files++][0],st.name);	    	    	    	    
	    //strcpy(kk,st.name);
	 }	  	
  }

if(zip_num_files!=1)
	{
	COLORFONDO=0;  gp2x_flip();
	while(gp2x_nKeys & (GP2X_X)) gp2x_nKeys=gp2x_joystick_poll(); // para quieto!!   
	while(1)
		{
		gp2x_waitvsync();gp2x_noflip_buffering();ClearScreen(COLORFONDO);
    		sprintf(cad,"ZIP LIST (%u)",zip_num_files);  
    		v_putcad(0,1,4,cad);
    		m=0;
   
		for(n=posfile-10;n<posfile+24;n++)
	    		{
       			if(n<0) continue;
	   		if(n>=zip_num_files) break;
	   		if(m>23) break;
	   		if(n==posfile) COLORFONDO=1; else COLORFONDO=6;
	   		v_breakcad=38;v_forcebreakcad=1;
       			v_putcad(1,m+3,2,zip_files[n]);
	   		v_breakcad=40;v_forcebreakcad=0;
	   		COLORFONDO=0;
	   		m++;
			}
	
		for(;m<24;n++)//lo que falta
			{
			COLORFONDO=6;
			v_breakcad=38;v_forcebreakcad=1;
			v_putcad(1,m+3,2," ");
			v_breakcad=40;v_forcebreakcad=0;
			COLORFONDO=0;
			m++;
			}
		v_putcad(1,28,4,"Press LFT/MID to Select ZIP Entry");
	
		/*	
    		int y=6;
		v_putcad(30,y,4,"Press A/X");y+=2;
		v_putcad(30,y,4,"to Play");y+=2;
    		*/
	    	gp2x_nKeys=gp2x_joystick_poll();
		new_key=gp2x_nKeys & (~old_key);
		old_key=gp2x_nKeys;
		
		if(!(old_key & (GP2X_UP | GP2X_DOWN))) f=0;
		if(old_key & GP2X_UP)
			{
			if(f==0) f=2;
			else if(f & 1) f=2;
			else {f+=2;if(f>40) {f=34;new_key|=GP2X_UP;}}
			}
		if(old_key & GP2X_DOWN)
			{
			if(f==0) f=1;
			else if(!(f & 1)) f=1;
			else {f+=2;if(f>41) {f=35;new_key|=GP2X_DOWN;}}
			}
	
		if(new_key & (GP2X_A | GP2X_X)) 
			{
			break;
			}		
		if((new_key & GP2X_L)) {posfile-=25;if(posfile<0) posfile=0;}
	    	if((new_key & GP2X_R)) {posfile+=25;if(posfile>=zip_num_files) posfile=zip_num_files-1;}

		if((new_key & GP2X_UP)) {posfile--;if(posfile<0) posfile=zip_num_files-1;}
    		if((new_key & GP2X_DOWN)){posfile++;if(posfile>=zip_num_files) posfile=0;} 	              
		}
	}
else	{
   	posfile=0;
	}

////seleccionar
idx=zip_pos_file[posfile];

//if(idx==m) {zip_close(za);return -2;}

zip_stat_index(za, idx , 0, &st);
 
GAME_size=st.size;
 //st.crc;
		
fp=zip_fopen_index(za, idx,0);

m=0;
while(1)
	{
     n=zip_fread(fp,GAME+m,GAME_size-m);
	if(n>0) m+=n; else break;
	}
if(n<0 || m!=GAME_size) GAME_size=0;
zip_fclose(fp);
zip_close(za);
return 0;
}

#endif


void load_empty_dsk()
{
int len_d=1*1024*1024;

	BZ_API(BZ2_bzBuffToBuffDecompress) ((void *)DSK, (void *)&len_d,(void *)empty_dsk, size_empty_dsk,0,0);
}

int load_game(char *name)
{
FILE *fp;

GAME_size=0;

MY_filename=name;
fp=fopen(name,"rb");
if(fp==NULL) return -1;

#ifdef USE_ZIP
if(is_ext (name, ".zip"))
	{
	zip_load(name); return 0;
	}
#endif
if(is_ext (name, ".bz2"))
	{
	BZFILE * my_bzip;
	int bzip_err=0;	
	
	my_bzip=BZ2_bzReadOpen( &bzip_err, fp, 0, 1, NULL, 0 );
	
	GAME_size=BZ2_bzRead (&bzip_err, my_bzip, GAME, 1*1024*1024);
	
	BZ2_bzReadClose (&bzip_err, my_bzip);
    fclose(fp);
	return 0;
	}
fseek(fp,0,SEEK_END);
GAME_size=ftell(fp);
fseek(fp,0,SEEK_SET);
fread(GAME, 1, GAME_size, fp);
fclose(fp);
return 0;
}

int compress_rom(char *name)
{

int i,n,m;
char filename[256];
BZFILE * my_bzip;
int bzip_err=0;
char *temp;
FILE *fp, *fp_bzip;
strcpy(filename,name);

temp=malloc(1024*2048);
if(!temp) return -3;

strcat(filename,".bz2");

fp = fopen(name, "rb");
if (fp == NULL) {free(temp);return -1;}

fp_bzip = fopen(filename, "wb");
if (fp_bzip == NULL) {free(temp);fclose(fp);return -2;}
	
fseek(fp,0,SEEK_END);
m = ftell(fp);
fseek(fp,0,SEEK_SET);
if(m>(1024*2048)) {free(temp);fclose(fp);fclose(fp_bzip);return -3;}
n=fread(temp,1,m,fp);
fclose(fp); 
if(n<m) {free(temp);fclose(fp_bzip);return -4;}



my_bzip=BZ2_bzWriteOpen( &bzip_err, fp_bzip, 4, 0,30);
if(bzip_err!=BZ_OK)  {free(temp);fclose(fp_bzip);return -5;}

BZ2_bzWrite (&bzip_err, my_bzip, temp,  m);
i=bzip_err;	
BZ2_bzWriteClose (&bzip_err, my_bzip,0,(void*)&n,(void*)&m);
fclose(fp_bzip);
free(temp);
if(i!=BZ_OK || bzip_err!=BZ_OK)
	{
	remove(filename);
	 return -5;
	}
else remove(name);


return 0;
}
struct 
{
unsigned header;
int mJoystick;
int map_keys[16];
unsigned char filename[256];
int have_fd_info;
unsigned reserved[63];
} state_header;


#define SIZEOFZ80REGS sizeof(Z80Regs)




t_track  track_temp;
#define RESTA_PUNT(a) if((int)a!=0)  a-=(unsigned) DSK; else a= (void*)/*(unsigned)*/ -1
#define SUMA_PUNT(a) if((int) a!=-1)  a+=(unsigned) DSK; else a= (void*)/*(unsigned)*/ 0
int save_state(int st)
{
    FILE * fp; unsigned char *mem;
    int count,n,m;
	char *mname;
    char savefile[256];
    BZFILE * my_bzip;
	int bzip_err=0;
	int file_error=0;
	
	mname=get_name(MY_filename);
	// obten nombre sin extension
	n=0;while(mname[n]!=0) n++;
	while(n>0) {if(mname[n]=='.') {mname[n]=0;break;} n--;}

	sprintf(photo_name,"%s/saves/%s.tmp",globalpath,mname);
    sprintf(savefile,"%s/saves/%s.sav",globalpath,mname);
	fp=fopen(photo_name,"wb");
	if(fp==NULL) return 0;

	my_bzip=BZ2_bzWriteOpen( &bzip_err, fp, 4, 0,30);
   if(bzip_err!=BZ_OK)  {fclose(fp);return 0;}
				
    mem=(unsigned char*) malloc(16384*16+SIZEOFZ80REGS+100);
    if(mem==NULL) {BZ2_bzWriteClose (&bzip_err, my_bzip,0,(void*)&n,(void*)&m);fclose(fp);return 0;}

    state_header.header=0x12345678;

    state_header.mJoystick=mJoystick;
	for(n=0;n<14;n++) state_header.map_keys[n]=map_keys[n];
	if(!is_ext(MY_filename,".sav")) strcpy((void*)state_header.filename,MY_filename);
    
	if(model==ZX_PLUS3) state_header.have_fd_info=1; else state_header.have_fd_info=0;

	BZ2_bzWrite (&bzip_err, my_bzip, (void *)&state_header,  sizeof(state_header));
    if(bzip_err!=BZ_OK) {file_error=1;}

	else
	{
	if(state_header.have_fd_info==1)
		{		
		BZ2_bzWrite (&bzip_err, my_bzip, (void *) &driveA.current_track,  4);
		BZ2_bzWrite (&bzip_err, my_bzip, (void *) &driveA.current_side,  4);
		BZ2_bzWrite (&bzip_err, my_bzip, (void *) &driveA.current_sector,  4);
		BZ2_bzWrite (&bzip_err, my_bzip, (void *) &driveA.flipped,  4);
		RESTA_PUNT(FDC.buffer_ptr);
		RESTA_PUNT(FDC.buffer_endptr);
		BZ2_bzWrite (&bzip_err, my_bzip, (void *) &FDC,  sizeof (t_FDC));
		SUMA_PUNT(FDC.buffer_ptr);
		SUMA_PUNT(FDC.buffer_endptr);
		if(active_track) memcpy(&track_temp,active_track,sizeof (t_track)); else memset(&track_temp,0,sizeof (t_track));
		RESTA_PUNT(track_temp.data);
		for(n=0;n<track_temp.sectors;n++)
        {
        RESTA_PUNT(track_temp.sector[n].data);
        }
		BZ2_bzWrite (&bzip_err, my_bzip, (void *) &track_temp,  sizeof (t_track));
        //if(bzip_err!=BZ_OK) {file_error=1;}
		}
	if(!file_error)
	{
    count=ZX_SaveState(&mem[0]);

    BZ2_bzWrite (&bzip_err, my_bzip, (void *)&mem[0],  count);
    if(bzip_err!=BZ_OK) {file_error=1;}
	}
	}

	BZ2_bzWriteClose (&bzip_err, my_bzip,0,(void*)&n,(void*)&m);
	if(bzip_err!=BZ_OK) {file_error=1;}
	fclose(fp);
	if(!file_error)
    {
    remove(savefile);
    rename(photo_name,savefile);
    }
    else remove(photo_name);
	
    free(mem);

    return 1;
}

t_FDC FDC_temp;
t_drive disk_temp;

void fdc_readtrk2(void);

int load_state(int st)
{
    FILE * fp; unsigned char *mem;
    unsigned size;	
	char *mname;

	BZFILE * my_bzip;
	int bzip_err=0;
	int n;
	mname=get_name(MY_filename);
	// obten nombre sin extension
	n=0;while(mname[n]!=0) n++;
	while(n>0) {if(mname[n]=='.') {mname[n]=0;break;} n--;}

	sprintf(photo_name,"%s/saves/%s.sav",globalpath,mname);

	fp=fopen(photo_name,"rb");
	if(fp==NULL) return 0;

	my_bzip=BZ2_bzReadOpen( &bzip_err, fp, 0, 1, NULL, 0 );

    	size=BZ2_bzRead (&bzip_err, my_bzip, (void *)&state_header, sizeof(state_header));
	
	if(state_header.header!=0x12345678) {BZ2_bzReadClose (&bzip_err, my_bzip);fclose(fp);return 0;}
	
	if(state_header.have_fd_info==1)
	{
		BZ2_bzRead (&bzip_err, my_bzip, (void *) &disk_temp.current_track,  4);
		BZ2_bzRead (&bzip_err, my_bzip, (void *) &disk_temp.current_side,  4);
		BZ2_bzRead (&bzip_err, my_bzip, (void *) &disk_temp.current_sector,  4);
		BZ2_bzRead (&bzip_err, my_bzip, (void *) &disk_temp.flipped,  4);
		BZ2_bzRead (&bzip_err, my_bzip, (void *) &FDC_temp,  sizeof (t_FDC));
		BZ2_bzRead (&bzip_err, my_bzip, (void *) &track_temp,  sizeof (t_track));
		SUMA_PUNT(track_temp.data);
        for(n=0;n<track_temp.sectors;n++)
        {
        	SUMA_PUNT(track_temp.sector[n].data);
        }		
	}
   
    mem=(unsigned char*) malloc(16384*16+SIZEOFZ80REGS+100);
    if(mem==NULL) {BZ2_bzReadClose (&bzip_err, my_bzip);fclose(fp);return 0;}

    size=BZ2_bzRead (&bzip_err, my_bzip, (void *)&mem[0], 16384*16+SIZEOFZ80REGS+100);
	
	BZ2_bzReadClose (&bzip_err, my_bzip);fclose(fp);
	mJoystick=state_header.mJoystick;
	for(n=0;n<12;n++) map_keys[n]=state_header.map_keys[n];
  	if(map_keys[8]==0) map_keys[8]=SPECKEY_SHIFT;
	if(map_keys[9]==0) map_keys[9]=SPECKEY_SYMB;
  	if(map_keys[10]==0) map_keys[10]=SDLK_SPACE;
	if(map_keys[11]==0) map_keys[11]=SDLK_PERIOD;
	
	MY_filename=(char*)state_header.filename ;

	#ifdef DEBUG_MSG
	printf("Load State:\n%s\n",state_header.filename);
    #endif
	
    memset(DSK,0,1*1024*1024);
    load_empty_dsk(); // disco comprimido formateado por defecto

	if(!is_ext((char*)state_header.filename,".sav"))
	load_game((char*)state_header.filename );
	else {load_game("fake_name.fak");}
    ZX_LoadGame(ZX_128, /*MyGameCRC*/0, 0/*mQuick*/);

	

    {
    int code = 0;
    code=ZX_LoadState(&mem[0]);
	
    
    free(mem);
	
	
   if(state_header.have_fd_info==1)
	{dsk_load(DSK);
    SUMA_PUNT(FDC_temp.buffer_ptr);
    SUMA_PUNT(FDC_temp.buffer_endptr);
    FDC_temp.cmd_handler=FDC.cmd_handler;
    FDC=FDC_temp;
     driveA.current_track=disk_temp.current_track;
     driveA.current_side=disk_temp.current_side; 
	 driveA.current_sector=disk_temp.current_sector;
	 driveA.flipped=disk_temp.flipped;
	
	
	active_track=&track_temp;
	}
    return (code?1:0);
    }	
}

void
tape_browser()
{
	
	char cad[256];
	int posfile=0;
	unsigned new_key=0,old_key=0;
	int n=0;
	int m=0;
	int f=0;
	
	int max_blocks = 1024;
	char block_entries[1024][256];	
	int num_entries = tape_blocks_entries(block_entries,38);
		
	posfile=tape_get_current_block();
	
	COLORFONDO=0;  gp2x_flip();
	while(gp2x_nKeys & (GP2X_A | GP2X_X)) gp2x_nKeys=gp2x_joystick_poll(); // para quieto!!   
	while(1)
		{			
		gp2x_waitvsync();gp2x_noflip_buffering();ClearScreen(COLORFONDO);//speccy_corner();
		sprintf(cad,"TAPE BLOCK LIST (%u) TAPE:%s",num_entries,tape_playing?"ON":"OFF");  
	    	v_putcad(0,1,4,cad);
	    	m=0;
	   
		for(n=posfile-10;n<posfile+22;n++)
	    		{
					int col;
	       		if(n<0) continue;
		   	if(n>=num_entries) break;
		   	if(m>21) break;
		   	col = 2;
		   	if (n==tape_get_current_block()) 
			col = tape_playing ? 4 : 3 ; 
		   		   
		   	if(n==posfile) COLORFONDO=1;
		   	else COLORFONDO=6;
		   	v_breakcad=38;v_forcebreakcad=1;
	       		v_putcad(1,m+3,col,block_entries[n]);     	       
		   	v_breakcad=40;v_forcebreakcad=0;
		   	if (n==tape_get_current_block()) 
			v_putcad(6,m+3,col,"*");
		   	COLORFONDO=0;
		   	m++;
			}
		
		for(;m<22;n++)//lo que falta
		{
			COLORFONDO=6;
			v_breakcad=38;v_forcebreakcad=1;
			v_putcad(1,m+3,2," ");
			v_breakcad=40;v_forcebreakcad=0;
			COLORFONDO=0;
			m++;
		}
		
	    
	    v_putcad(1,26,4,"Press C to Exit,RGT to New Tape"); 
	    v_putcad(1,27,4,"LFT/MID to Toggle Tape Play");
	    v_putcad(1,28,4,"        or Change Block");
	    
	    gp2x_nKeys=gp2x_joystick_poll();	
		new_key=gp2x_nKeys & (~old_key); 
		old_key=gp2x_nKeys;	
		
		if(new_key & (GP2X_X)) 
		{
			if(posfile==tape_get_current_block())
			{
			   tape_toggle_play(1);//cuidado que avanza
			   if(posfile==tape_get_current_block())
			      tape_select_block(posfile);
			}   
			else
			  tape_select_block(posfile);
		}
	    
		if(new_key & (GP2X_SELECT )) 
		{
		    break;
		}
		
		if(new_key & (GP2X_Y)) 
		{
			char *mname;
			int ret;
            int r=get_rom(1);
            while(gp2x_nKeys & (GP2X_SELECT  | GP2X_A | GP2X_X | GP2X_Y)) gp2x_nKeys=gp2x_joystick_poll(); // para quieto!!   
            if(r==-1) continue;            
            ret=0;
		    ret=load_game(&files[r][0]);
		    mname=get_name(MY_filename);
		    // obten nombre sin extension
		    n=0;while(mname[n]!=0) n++;
		    while(n>0) {if(mname[n]=='.') {mname[n]=0;break;} n--;}
		       sprintf(photo_name,"%s/saves/%s.key",globalpath,mname);
		    read_keyfile(photo_name);
		    ZX_LoadGame(-1,0,0);	
		    while(gp2x_nKeys & (GP2X_A | GP2X_X)) gp2x_nKeys=gp2x_joystick_poll(); // para quieto!!   	    
		    num_entries = tape_blocks_entries(block_entries,38);
		    posfile=tape_get_current_block();
		    //TODO chequear esto	     
		}		    
	    
	    if((new_key & GP2X_L)) {posfile-=24;if(posfile<0) posfile=0;}
	    if((new_key & GP2X_R)) {posfile+=24;if(posfile>=num_entries) posfile=num_entries-1;}
	    
        if(!(old_key  & (GP2X_UP | GP2X_DOWN))) f=0;
	    if(old_key  & GP2X_UP)
		{
		   if(f==0) f=2;
		   else if(f & 1) f=2;
		   else {f+=2;if(f>40) {f=34;new_key|=GP2X_UP;}}
		}
	    if(old_key  & GP2X_DOWN)
		{
		   if(f==0) f=1;
		   else if(!(f & 1)) f=1;
		   else {f+=2;if(f>41) {f=35;new_key|=GP2X_DOWN;}}
		}
	
	    if((new_key & GP2X_UP)) {posfile--;if(posfile<0) posfile=num_entries-1;}
	    if((new_key & GP2X_DOWN)){posfile++;if(posfile>=num_entries) posfile=0;} 	              
	}
	
}


unsigned oldtime=0;
unsigned fpstime=0;
int sel_key=0;
int nvol=0;
int fpsseg=0;
int count_fps=0;
long tape_stop_delay=0;

INLINE int render_frame(int skipthisframe)
	{
	unsigned time;
	ZX_Frame(skipthisframe);

	Sound_Loop();

	if (keyboard_on==0)
		{
		if (gp2x_nKeys & GP2X_SELECT)
			{
			emu_running = 0;
			SDL_ShowCursor(1);
			if(Config_SCR()==1) 
				return 1;
			SDL_ShowCursor(0);
			target_fps = 1000/delayvalue;
			reset_timing = 1;
			emu_running = 1;
			}
		}

	gp2x_nKeys=gp2x_joystick_poll();

	new_key=gp2x_nKeys & (~old_key);
	old_key=gp2x_nKeys;
	//    if((old_key & GP2X_L) && (gp2x_nKeys  & GP2X_SELECT)) break;
	//SONIDO!

	if((old_key & GP2X_VOL_UP) && (nvol % 3 == 0))
		{volume+=1;if(volume>100) volume=100;gp2x_volume(volume,volume);nvol=50*5;}
	if((old_key & GP2X_VOL_DOWN) && (nvol % 3 == 0))
		{volume-=1;if(volume<0) volume=0;gp2x_volume(volume,volume);nvol=50*5;}


	if(nvol!=0)
		{
		char result[3]; 
		sprintf( result, "%d", volume ); 
		v_putcad(0,1,4,result);
		nvol--;
		}

	if(mconfig.show_fps)
		{        
		char result[8]; 
		int tmp = COLORFONDO;
		if(gp2x_timer_poll() - fpstime > 1000)
			{           
			fpsseg = count_fps;
			count_fps = 0;   
			fpstime = gp2x_timer_poll();
			}
		count_fps++;        
		snprintf( result,8, "%d/%d",frames_rendered, fpsseg );   

		if(!full_screen)
			{
			COLORFONDO=4;
			v_putcad(0,0,4,result);
			}
		else
			{
			v_putcad(4,3,4,result);
			}
		COLORFONDO=tmp;
		cur_frame++;
		}

	if(tape_playing && mconfig.speed_loading)
		{
		if(!init_speed_loading)
			{
			init_speed_loading=1;             
			sound_pause();
			}
#pragma message("FIX SPEED LOADING")
		//skip = !(cur_frame % 4 == 0);//1 de 3 frames    
		}    
	else
		{
		if(init_speed_loading)
			{
			init_speed_loading=0;   
#pragma message("FIX SPEED LOADING")
			//skip = 0;
			sound_unpause(); 
			}
		//skip^=mconfig.frameskip;
		}

	if(tape_playing)
		{                                 	     	
		int tmp = COLORFONDO;

		if(fast_edge_loading!=2)
			{
			COLORFONDO=/*6*/0;	
			v_putcad(320/8-5,240/8-2,/*0*/6,"PLAY");
			}
		else
			{
			COLORFONDO=/*4*/0;
			v_putcad(320/8-5,240/8-2,/*0*/4,"PLAY");
			}   
		COLORFONDO=tmp;
		tape_stop_delay = 3000;                        
		}
	else if(tape_stop_delay >=0)
		{
		int tmp = COLORFONDO;
		int x;
		int y;
		tape_stop_delay -= 20;


		x = full_screen ? 256 : 320;
		y = full_screen ? 192 : 240;
		COLORFONDO=/*2*/0;
		v_putcad(x/8-5,y/8-2,2,"STOP");
		COLORFONDO=tmp;
		}

	if(new_key & GP2X_START) 
		{
		keyboard_on^=1;program_mode=0;menu_mode=0;
		}

	if(keyboard_on) 
		{
		if(old_key & (GP2X_X))
			{
			ZXKey(sel_key);
			}
		if(autoload)
			{
			if(autoload==1 || autoload==2)
				{
				ZXKey(SPECKEY_J);
				}
			if(autoload==11 || autoload==12 || autoload==21|| autoload==22)
				{
				ZXKey(SPECKEY_SYMB);
				ZXKey(SPECKEY_P);
				}
			if(autoload==30)
				{
				ZXKey(SPECKEY_ENTER);
				}
			if(autoload==31)
				{
				ZXKey(SPECKEY_ENTER);
				autoload=-1;
				}
			autoload++;
			}
		}
	else
		{//left/right/up/down/a,b,x,y/L,R

		switch(mJoystick)
			{
			case 1://kempston


				if(old_key & GP2X_LEFT)  kempston|=2;
				if(old_key & GP2X_RIGHT) kempston|=1; 
				if(old_key & GP2X_UP)    kempston|=8;
				if(old_key & GP2X_DOWN)  kempston|=4;
				if(old_key & GP2X_A)     kempston|=16;
				break;

			case 2:
				//Sinclair Joystick 1,Interface II (port 1)

				if(old_key & GP2X_LEFT)  ZXKey(SPECKEY_6);
				if(old_key & GP2X_RIGHT) ZXKey(SPECKEY_7);
				if(old_key & GP2X_UP)    ZXKey(SPECKEY_9);
				if(old_key & GP2X_DOWN)  ZXKey(SPECKEY_8);
				if(old_key & GP2X_A)     ZXKey(SPECKEY_0);
				break;

			case 3:
				//Sinclair Joystick 2,Interface II (port 2)
				if(old_key & GP2X_LEFT)  ZXKey(SPECKEY_1);
				if(old_key & GP2X_RIGHT) ZXKey(SPECKEY_2);
				if(old_key & GP2X_UP)    ZXKey(SPECKEY_4);
				if(old_key & GP2X_DOWN)  ZXKey(SPECKEY_3);
				if(old_key & GP2X_A)     ZXKey(SPECKEY_5);

				break;

			case 4:
				// Cursor
				if(old_key & GP2X_LEFT)  ZXKey(SPECKEY_5);
				if(old_key & GP2X_RIGHT) ZXKey(SPECKEY_8);
				if(old_key & GP2X_UP)    ZXKey(SPECKEY_7);
				if(old_key & GP2X_DOWN)  ZXKey(SPECKEY_6);
				if(old_key & GP2X_A)     ZXKey(SPECKEY_0);

				break;

			case 5:
				//fuller

				if(old_key & GP2X_LEFT)  fuller&=0xFF-4; 
				if(old_key & GP2X_RIGHT) fuller&=0xFF-8; 
				if(old_key & GP2X_UP)    fuller&=0xFF-1; 
				if(old_key & GP2X_DOWN)  fuller&=0xFF-2; 
				if(old_key & GP2X_A)     fuller&=0xFF-128;
				break;

			default: // keyboard
				if(old_key & GP2X_LEFT) ZXKey(map_keys[0]);
				if(old_key & GP2X_RIGHT) ZXKey(map_keys[1]);
				if(old_key & GP2X_UP) ZXKey(map_keys[2]);
				if(old_key & GP2X_DOWN) ZXKey(map_keys[3]);
				if(old_key & GP2X_A) ZXKey(map_keys[4]);
				break;

			}
		//if(old_key & GP2X_B) ZXKey(map_keys[5]);
		if(old_key & GP2X_X) ZXKey(map_keys[6]);
		//if(old_key & GP2X_Y) ZXKey(map_keys[7]);
		}
	//if(old_key & GP2X_L) ZXKey(map_keys[8]);
	//if(old_key & GP2X_R) ZXKey(map_keys[9]);

	if(keyboard_on)
		{
		sel_key=display_keyboard();
		if((old_key & (GP2X_Y))&&(unprogram==0))
			{
			ZXKey(sel_key);keyboard_on=0;keyboard_press=4;
			}
		}
	else	{
	if (keyboard_press)
		{
		ZXKey(sel_key);
		keyboard_press--;
		}
	}
	if(unprogram)
		{
		unprogram--;
		}

	if(skipthisframe==0)
		{	  		
		gp2x_flip();

		//Seleuco: Esta temporizacin solamente se tiene que hacer si no se reproduce Audio. Para evitar underuns dejar que temporice el audio si existe sonido.   
		if(mconfig.sound_mode==0 && !(mconfig.speed_loading && tape_playing))
			{  		
			do	
				{
				time=gp2x_timer_poll();
				}    		
			while((time-oldtime)<delayvalue); // asegura la temporizacion

			oldtime=time;    	
			}
		}
	return 0;
	}

int main(int argc, char *argv[])
{
int i,r,n,ret;
int aa,bb;
Z80Regs regs_z80;
char *mname;
char *currentdir;
FILE *fp;
int l;
int startname;
int lextension;
int largv0;
int cutpath=0;
int breakwhile = 0;
#ifdef DEBUG_MSG
printf("Iniciando gp2xpectrum\n");
#endif
gp2x_init();

cur_frame=0;	

MY_filename="default_name.fak";
spectrumZ80=&regs_z80;

//load_mconfig();//error no esta puesto el global path

currentdir=(char*) "c:/data/";//get_current_dir_name();

if ((currentdir[0]=='/')&&(currentdir[1]=='t')&&(currentdir[2]=='m')&&(currentdir[3]=='p'))
	{
	cutpath=4;
	}
for(aa=cutpath;aa<strlen(currentdir);aa++)
	{
	pathstring[aa-cutpath]=currentdir[aa];
	}
pathstring[aa-cutpath]=0;
l=strlen(pathstring);
largv0=strlen(argv[0]);
startname=l;
lextension=3;

if(argv[0][largv0-1]=='p')
	{
	// Ejecutable comprimido
	startname=8;
	lextension=7;
	}
else if(argv[0][0]=='.')
	{
	startname=1;
	}
for(aa=startname;aa<(largv0-lextension);aa++)
	{
	pathstring[aa+l-startname]=argv[0][aa];
	}
	
pathstring[aa+l-startname]='i';
pathstring[aa+l-startname+1]='n';
pathstring[aa+l-startname+2]='i';
pathstring[aa+l-startname+3]=0;

fp=fopen(pathstring,"rb");
if(fp!=NULL)
	{
	aa=fread(pathstring3, 1, 300, fp);
	pathstring3[aa]=0;
	fclose(fp);
	if (pathstring3[0]=='/')
		{
		if ((pathstring3[1]=='m')&&(pathstring3[2]=='n')&&(pathstring3[3]=='t'))
			{
			// Si comienza con /mnt -> se copia tal cual
			for(bb=0;(bb<=aa)&&(pathstring3[bb]>13);bb++)
				{
				globalpath[bb]=pathstring3[bb];
				}
			globalpath[bb]=0;
			}
		else	{
			// Si comienza con /(otra cosa) -> se copia tal cual a partir del /mnt/sd
			for(bb=0;(bb<=aa)&&(pathstring3[bb]>13);bb++)
				{
				globalpath[bb+7]=pathstring3[bb];
				}
			globalpath[bb+7]=0;
			}
		}
	else	{
		if ((pathstring3[0]=='.')&&(pathstring3[1]=='/'))
			{
			// Si comienza con ./ -> se copia del pathstring a partir de l
			for(bb=0;(bb<l)&&(pathstring[bb]>13);bb++)
				{
				globalpath[bb]=pathstring[bb];
				}
			for(bb=0;(bb<=aa)&&(pathstring3[bb]>13);bb++)
				{
				globalpath[bb+l]=pathstring3[bb];
				}
			globalpath[bb+l]=0;
			}
		else	{
			// Si comienza con (otra cosa) -> se copia tal cual a partir del /mnt/sd/
			for(bb=0;(bb<=aa)&&(pathstring3[bb]>13);bb++)
				{
				globalpath[bb+8]=pathstring3[bb];
				}
			globalpath[bb+8]=0;
			}
		}
	}

// CREAR RUTA...
aa=0;
for(i=1;i<strlen(globalpath);i++)
	{
	if (globalpath[i]=='/')
		{
		aa++;
		if (aa>2)
			{
			strncpy(pathstring2,globalpath,i);
			sprintf(pathstring,"%s",pathstring2);
			mkdir(pathstring,S_IREAD | S_IWRITE);
			}
		}
	}
	
sprintf(pathstring,"%s",globalpath);
sprintf(pathstring2,"%s/saves",globalpath);
sprintf(pathstring3,"%s/img",globalpath);	
mkdir(pathstring,S_IREAD | S_IWRITE);
mkdir(pathstring2,S_IREAD | S_IWRITE);
mkdir(pathstring3,S_IREAD | S_IWRITE);

credits();
//volume=50;
 
load_mconfig();
sprintf(pathstring,"%s/saves/gp2xpectrum.key",globalpath);
read_keyfile(pathstring);
sound_init(-1,-1);
gp2x_open_sound(mconfig.sound_freq,16,mconfig.sound_mode >= 2);
gp2x_volume(volume,volume);

tape_init();

ZX_Init();
target_fps = 50;
while(1)
{
do{gp2x_nKeys=gp2x_joystick_poll();}while(gp2x_nKeys  & (GP2X_SELECT   | GP2X_X));

SetVideoScaling(320,320,240);

memset(DSK,0,1*1024*1024);
load_empty_dsk(); // disco comprimido formateado por defecto
nvol=0;
dsk_flipped=0;
r=get_rom(0);
if(r==-1) break;
ret=0;
if(r>=0)
	{if(is_ext (&files[r][0], ".sav"))	{MY_filename=&files[r][0];load_state(0);ret=666;}
     else
		{ret=load_game(&files[r][0]);
	    mname=get_name(MY_filename);
		// obten nombre sin extension
		n=0;while(mname[n]!=0) n++;
		while(n>0) {if(mname[n]=='.') {mname[n]=0;break;} n--;}
		sprintf(photo_name,"%s/saves/%s.key",globalpath,mname);
		read_keyfile(photo_name);
		}
	}


// inicializa variables de teclado virtual
keyboard_on=0;
keyboard_press=0;
autoload=0;
program_mode=0;
menu_mode=0;
redrawmask=1;

ClearScreen(COLORFONDO);gp2x_waitvsync();
gp2x_flip();
ClearScreen(COLORFONDO);gp2x_waitvsync();
gp2x_flip();

set_emupalette();
//GAME_size=MyGameSize;
if(ret!=666) ZX_LoadGame(ZX_128, /*MyGameCRC*/0, 0/*mQuick*/);

count_fps=0;
thissec = 0, frames_done = 0, frames_shown = 0;
target_frametime = delayvalue*1000;//1000000/target_fps;
reset_timing = 1;
emu_running = 1;
breakwhile = 0;
SDL_ShowCursor(0);
target_fps = 1000/delayvalue;

while(!breakwhile)
 {
 #ifdef  CAPTURE
if((old_key & GP2X_VOL_UP) && (old_key & GP2X_SELECT))
 {
 sprintf(pathstring,"%s/img/ingame.bmp",globalpath);
 save_bmp(pathstring, gp2x_screen, 320-64*full_screen, 240-48*full_screen, 320);
 }
 #endif

Picture=gp2x_screen;
if (keyboard_on==0 && !tape_playing)
	{
	full_screen=mconfig.zx_screen_mode;
	if(full_screen) 
		{
		Picture+=((320*24)+32);
		SetVideoScaling(320,256,192);
		}
	else 
		SetVideoScaling(320,320,240);
	}
else
	{
	full_screen=0;
	SetVideoScaling(320,320,240);
	}

gettimeofday(&tval, 0);
if(reset_timing) 
	{
	reset_timing = 0;
	thissec = tval.tv_sec;
	frames_done = tval.tv_usec/target_frametime;
	}


// second changed?
if(thissec != tval.tv_sec) 
	{
	thissec = tval.tv_sec;
	frames_rendered = frames_shown;
	
	if(mconfig.sound_mode == 0 && mconfig.frameskip >= 0) 
		{
		frames_done = frames_shown = 0;
		} 
	else
		{
		// it is quite common for this implementation to leave 1 frame unfinished
		// when second changes, but we don't want buffer to starve.
		if(mconfig.sound_mode!=0 && frames_done < target_fps && frames_done > target_fps-5) 
			{
			breakwhile+=render_frame(1);///*InputFrame();*/ frames_done++;
			}

		frames_done  -= target_fps; if (frames_done  < 0) frames_done  = 0;
		frames_shown -= target_fps; if (frames_shown < 0) frames_shown = 0;
		if (frames_shown > frames_done) frames_shown = frames_done;
		}
	}


lim_time = (frames_done+1) * target_frametime;
if(mconfig.frameskip >= 0) 
	{ // frameskip enabled
	for(i = 0; i < mconfig.frameskip; i++) 
		{
		/*InputFrame();*/breakwhile+=render_frame(1); frames_done++;
		if (mconfig.sound_mode!=0) 
			{ 
			// do framelimitting if sound is enabled
			gettimeofday(&tval, 0);
			if(thissec != tval.tv_sec) tval.tv_usec+=1000000;
			if(tval.tv_usec < lim_time) 
				{ // we are too fast
				simpleWait(thissec, lim_time);
				}
			}
		lim_time += target_frametime;
		}
	} 
else if(tval.tv_usec > lim_time) 
	{ // auto frameskip
	// no time left for this frame - skip
	/*InputFrame();*/breakwhile+=render_frame(1); frames_done++;
	continue;
	}

breakwhile+=render_frame(0);

// check time
gettimeofday(&tval, 0);
if(thissec != tval.tv_sec) 
	tval.tv_usec+=1000000;

// sleep if we are still too fast
if(mconfig.sound_mode != 0 || mconfig.frameskip < 0)
	{
	// TODO: check if User::After() is accurate
	gettimeofday(&tval, 0);
	if(thissec != tval.tv_sec) tval.tv_usec+=1000000;
	if(tval.tv_usec < lim_time)
		{
		// we are too fast
		simpleWait(thissec, lim_time);
		}
	}

  frames_done++; frames_shown++;
//if(!keyboard_on)
	 //skip^=mconfig.frameskip;
//else skip=0;
    
 }
 
sound_end();
}
SetVideoScaling(320,320,240);
save_mconfig();
sprintf(pathstring,"%s/saves/gp2xpectrum.key",globalpath);
write_keyfile(pathstring);
ClearScreen(0);
gp2x_flip();
ClearScreen(0);
gp2x_flip();

tape_finish();

gp2x_volume(70,70);
gp2x_close_sound();

gp2x_end();
return(0);
}
