/*  gp2xpectrum  for GP2X

    Copyright (C) 2006-2008 Metalbrain, Seleuco
    Copyright (C) 2006  Hermes/PS2Reality  * Made in Vallecas - Madrid (Spain)

    Copyright (C) 2004  rlyeh (fZX32 for GP32)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/****************************************************************************************************************/
// POKE MANAGER
/****************************************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <sdl.h>
#include <sys\time.h>
#include "shared.h"
#include "microlib.h"
#include "zx.h"
extern unsigned gp2x_nKeys;
extern unsigned char COLORFONDO;
extern MCONFIG mconfig;
extern int lastx;
extern char photo_name[256]; // nombre del fichero
extern char * MY_filename;
extern char globalpath[247];

extern char * get_name(char *name);
char * get_name_short(char *name);
//#define DEBUG_MSG 
#define USE_ZIP

// funciones para manejar los ficheros .pok
/*
formato
[TITLE1]
POKE add,data
*/

unsigned poke_table[5][10][2];
char poke_title[5][31];

void default_pokes()
{
int n,m;
for(n=0;n<5;n++)
	{
	sprintf(&poke_title[n][0],"POKE #%u",n+1);
    for(m=0;m<10;m++) {poke_table[n][m][0]=0;poke_table[n][m][1]=0;}
	}
}

void write_pokefile(char *name)
{
FILE *fp;
int n,m;

fp=fopen(name,"w");
if(fp==0) return;
for(n=0;n<5;n++)
	{
	fprintf(fp,"[%s]\n",&poke_title[n][0]);
	for(m=0;m<10;m++)
		{
		if(poke_table[n][m][0]>=16384) fprintf(fp,"POKE %u,%u\n",poke_table[n][m][0],poke_table[n][m][1]);
		
		}
	}
fclose(fp);
}
void read_pokefile(char *name)
{
FILE *fp;
int mode=0;
int n=0,m=0,i;
/*unsigned*/ char str_buf[256];


default_pokes();

fp=fopen(name,"r");
if(fp==0) return;

while(1)
	{
	if(fgets(str_buf,255,fp)==0) break;
	if(str_buf[0]=='[')
		{
		if(mode==1)  n++;
		if(n>4) break; // demasiadas entradas
		i=0;
		while(i<30 && str_buf[1+i]>=32 && str_buf[1+i]!=']')
			{poke_title[n][i]=str_buf[1+i];i++;}
		poke_title[n][i]=0; 
		mode=1;m=0;
		}
	else
	   {
	if(mode==0) continue; //ignora lineas hasta el proximo titulo
		if(sscanf(str_buf,"POKE %u,%u",&poke_table[n][m][0],&poke_table[n][m][1])==2) 
		   {
		   m++;if(m>=10) {mode=0;n++;}
		   }
		// else mode=0; //ignora lineas hasta el proximo titulo
	   }

	}
fclose(fp);
}


static char get_char_digit(unsigned num,int dig)
{
int n,m;
static char cad[5];
m=10000;
for(n=0;n<5;n++)
	{
	cad[n]=48+(num/m);
	num%=m;
	m/=10;
	}


return cad[4-dig];
}

static void change_digit1(unsigned *v,unsigned char ch,int pos)
{
static char cad[5];
unsigned m,n,num;
m=10000;
num=*v;
for(n=0;n<5;n++)
	{
	cad[n]=48+(num/m);
	num%=m;
	m/=10;
	}
cad[pos]=ch;
m=0;
for(n=0;n<5;n++)
	{
	m*=10;
	m+=cad[n]-48;
	}
if(m<65536) *v=m;
}
static void change_digit2(unsigned *v,unsigned char ch,int pos)
{
static char cad[5];
unsigned m,n,num;
m=100;
num=*v;
for(n=0;n<3;n++)
	{
	cad[n]=48+(num/m);
	num%=m;
	m/=10;
	}
cad[pos]=ch;
m=0;
for(n=0;n<3;n++)
	{
	m*=10;
	m+=cad[n]-48;
	}
if(m<256) *v=m;
}

extern void POKE(unsigned dir,unsigned char dat); // funcion de escritura en memoria en zx.c



int poke_manager()
{

int old_speed;
int n,m,y,g;
int op=0,op2=0;
unsigned new_key=0,old_key=0;
///unsigned char cad[256];
int ret=0;
int file_modified=0;
int editor_mode=0;
int poke_select=0;
 char *mname;

int pos=0,keypos=0;
char str_key[30][4]={
	 "A","B","C","D","E","F","G","H","I","J","K","L","M","N","Ent",
	 "O","P","Q","R","S","T","U","V","W","X","Y","Z"," ","/","Del"};
char num_key[10][4]={
	 "1","2","3","4","5","6","7","8","9","0"};
	 mname=get_name(MY_filename);
	 // obten nombre sin extension
	 n=0;while(mname[n]!=0) n++;
	 while(n>0) {if(mname[n]=='.') {mname[n]=0;break;} n--;}
	 sprintf(photo_name,"%s/saves/%s.pok",globalpath,mname);


read_pokefile(photo_name);


COLORFONDO=0;
while(gp2x_nKeys & (GP2X_Y | GP2X_X | GP2X_START)) gp2x_nKeys=gp2x_joystick_poll();

ClearScreen(COLORFONDO);

g=0;
while(1)
{COLORFONDO=0;	
#ifdef  CAPTURE
if((old_key & GP2X_VOL_UP) && (old_key & GP2X_SELECT))
	{
	sprintf(pathstring,"%s/img/poke_manager.bmp",globalpath);
	sprintf(pathstring2,"%s/img/poke_edit_name.bmp",globalpath);
	sprintf(pathstring3,"%s/img/poke_edit_values.bmp",globalpath);
    if(editor_mode==0) save_bmp(pathstring, gp2x_screen, 320, 240, 320);
	if(editor_mode==1) save_bmp(pathstring2, gp2x_screen, 320, 240, 320);
	if(editor_mode==2) save_bmp(pathstring3, gp2x_screen, 320, 240, 320);
	}
 #endif
 gp2x_waitvsync();gp2x_noflip_buffering();ClearScreen(COLORFONDO);speccy_corner();
    
	if(editor_mode==0)
	{
	COLORFONDO=0;
    v_putcad(14,0,4,"POKE MANAGER");
	y=4;
	if(op==0) COLORFONDO=1; else COLORFONDO=0;
	v_putcad(5,y,2,&poke_title[0][0]);
	y+=2;
	if(op==1) COLORFONDO=1; else COLORFONDO=0;
	v_putcad(5,y,2,&poke_title[1][0]);
	y+=2;
	if(op==2) COLORFONDO=1; else COLORFONDO=0;
	v_putcad(5,y,2,&poke_title[2][0]);
	y+=2;
	if(op==3) COLORFONDO=1; else COLORFONDO=0;
	v_putcad(5,y,2,&poke_title[3][0]);
	y+=2;
	if(op==4) COLORFONDO=1; else COLORFONDO=0;
	v_putcad(5,y,2,&poke_title[4][0]);
	y+=2;
	
	
	if(op==5) COLORFONDO=1; else COLORFONDO=0;
	v_putcad(5,y,2,"Return");y+=2;
    COLORFONDO=0;
	y+=4;
	v_putcad(2,y,4,"Use LFT/MID to SET, RGT to Edit");y+=2;
	v_putcad(2,y,4,"and C to Exit");
	}

    if(editor_mode==1)
	{
	COLORFONDO=0;
	v_putcad(11,0,4,"POKE TITLE EDITOR");
	y=4;
	COLORFONDO=0;
    v_putcad(5,y,2,&poke_title[poke_select][0]);
	COLORFONDO=1; 
	if(poke_title[poke_select][pos]<32) v_putchar(5+pos,y,2,' ');
    else v_putchar(5+pos,y,2,poke_title[poke_select][pos]);
	
	y=15; //teclado virtual
	n=0;
	for(n=0;n<30;n++)
	{
	if(keypos==n) COLORFONDO=1; else COLORFONDO=0;
	if(n==0 || n==15)  v_putcad(5,y+2*(n>=15),2,&str_key[n][0]);
	else v_putcad(lastx,y+2*(n>=15),2,&str_key[n][0]);
	lastx+=1;
	}
     
	 y=20;

	COLORFONDO=0;
	v_putcad((40-34)>>1,y,4,"Use */# to move the string cursor.");y+=2;
	v_putcad((40-34)>>1,y,4,"Use LEFT/RIGHT in Virtual Keyboard");y+=2;
    v_putcad((40-34)>>1,y,4,"Use LFT/MID to select");y+=2;
    v_putcad((40-34)>>1,y,4,"and C to abort");y+=2;
	
	}

	if(editor_mode==2)
	{
	COLORFONDO=0;
	v_putcad(11,0,4,"POKE VALUE EDITOR");
	y=4;
	
	for(n=0;n<10;n++)
		{
		COLORFONDO=0;
        v_putcad(5+16*(n & 1),y,2,"POKE ");
		for(m=0;m<5;m++) {if(pos==m && op2==n) COLORFONDO=1; else COLORFONDO=0;
			              v_putchar(lastx,y,2,get_char_digit(poke_table[poke_select][n][0],4-m));lastx++;
						  }
		COLORFONDO=0;
		v_putcad(lastx,y,2,",");lastx++;
		for(m=0;m<3;m++) {if(pos==m+5 && op2==n) COLORFONDO=1; else COLORFONDO=0;
		                  v_putchar(lastx,y,2,get_char_digit(poke_table[poke_select][n][1],2-m));lastx++;
					  }
					  	
		if(n & 1) y+=2;
		}
   

    y+=2;
   	n=0;
	for(n=0;n<10;n++) // teclado virtual
	{
	if(keypos==n) COLORFONDO=3; else COLORFONDO=1;
	if(n==0)  v_putcad(10,y,2,&num_key[n][0]);
	else v_putcad(lastx,y,2,&num_key[n][0]);
	v_putcad(lastx,y,2," ");
	}
     
	 y+=3;

	COLORFONDO=0;
	v_putcad((40-32)>>1,y,4,"Use UP/DOWN to select the POKE");y+=2;
	v_putcad((40-34)>>1,y,4,"Use L/R to move the numeric cursor.");y+=2;
	v_putcad((40-34)>>1,y,4,"Use LEFT/RIGHT in Virtual Keyboard");y+=2;
    v_putcad((40-34)>>1,y,4,"Use LFT/MID to select");y+=2;
    v_putcad((40-34)>>1,y,4,"and C or RGT to finish");y+=2;
	
	}

    gp2x_nKeys=gp2x_joystick_poll();
	
	new_key=gp2x_nKeys & (~old_key);
	old_key=gp2x_nKeys;  
   
    
	if(editor_mode==0)
	{
	if(!(old_key  & (GP2X_UP | GP2X_DOWN))) g=0;
	if(old_key  & GP2X_UP)
		{
		if(g==0) g=2;
		else if(g & 1) g=2;
		else {g+=2;if(g>80) {g=68;new_key|=GP2X_UP;}}
		}
	if(old_key  & GP2X_DOWN)
		{
		if(g==0) g=1;
		else if(!(g & 1)) g=1;
		else {g+=2;if(g>81) {g=69;new_key|=GP2X_DOWN;}}
		}
    if(new_key & GP2X_UP) {op--;if(op<0) op=5;}
	if(new_key & GP2X_DOWN) {op++;if(op>5) op=0;}
	

	if(new_key & GP2X_SELECT) {if(editor_mode) editor_mode=0; else break;}
    
	if((new_key & GP2X_Y) && op<5) {editor_mode=1;poke_select=op;pos=0;keypos=0;}
	if(new_key & (GP2X_X))
	{
	if(op>=0 && op<=4)
		{m=0;
		for(n=0;n<10;n++)
			{
			if(poke_table[op][n][0]!=0) {m=1;POKE(poke_table[op][n][0],poke_table[op][n][1]);}
			
			}
		if(m)
			{
			 for(n=0;n<60;n++)
			 {
			 gp2x_waitvsync();gp2x_noflip_buffering();ClearScreen(COLORFONDO);speccy_corner();COLORFONDO=0;
			 v_putcad(17,14,4,"Done!");
			 }
			}
		}

	if(op==5) break;
    }
	}
	else
	if(editor_mode==1)
	{
	if(new_key & GP2X_SELECT) {file_modified=0;if(editor_mode) editor_mode=0;}
	
	if(!(old_key  & (GP2X_LEFT | GP2X_RIGHT))) g=0;
    if(old_key  & GP2X_LEFT)
		{
		if(g==0) g=2;
		else if(g & 1) g=2;
		else {g+=2;if(g>80) {g=68;new_key|=GP2X_LEFT;}}
		}
	if(old_key  & GP2X_RIGHT)
		{
		if(g==0) g=1;
		else if(!(g & 1)) g=1;
		else {g+=2;if(g>81) {g=69;new_key|=GP2X_RIGHT;}}
		}
	if(new_key & GP2X_LEFT) {keypos--;if(keypos<0) keypos=29;}
    if(new_key & GP2X_RIGHT) {keypos++;if(keypos>29) keypos=0;}
	if(new_key & GP2X_UP) {keypos-=15;if(keypos<0) keypos=29;}
    if(new_key & GP2X_DOWN) {keypos+=15;if(keypos>29) keypos=0;}

	if(new_key & GP2X_L) {pos--;if(pos<0) pos=0;}
    if(new_key & GP2X_R) {if(poke_title[poke_select][pos]!=0) pos++;}
    if(new_key & (GP2X_X))
		{
		if(keypos==14) // enter
			{
			editor_mode=2;
			op2=0;keypos=0;pos=0;

			}
		else
		if(keypos==29) // del
			{
			if(pos!=0)
				{
				m=strlen(&poke_title[poke_select][0])+1;
				for(n=pos-1;n<m;n++) poke_title[poke_select][n]=poke_title[poke_select][n+1];
				pos--;if(pos<0)  pos=0;file_modified=1;
				}
			else
				{
				m=strlen(&poke_title[poke_select][0])+1;
				for(n=pos;n<m;n++) poke_title[poke_select][n]=poke_title[poke_select][n+1];
				file_modified=1;
				}
			}
		else 
			{
			if((m=strlen(&poke_title[poke_select][0]))<29)
				{
				m++;
				for(n=m;n>=pos;n--) poke_title[poke_select][n+1]=poke_title[poke_select][n];
				poke_title[poke_select][pos]=str_key[keypos][0];
				/*if(poke_title[poke_select][pos+1]!=0) */pos++;file_modified=1;
				}
			}
		}
	}
else
	if(editor_mode==2)
	{
	if(new_key & (GP2X_SELECT|GP2X_Y)) {file_modified=1;if(editor_mode) editor_mode=0;}
	if(!(old_key  & (GP2X_LEFT | GP2X_RIGHT))) g=0;
	if(old_key  & GP2X_LEFT)
		{
		if(g==0) g=2;
		else if(g & 1) g=2;
		else {g+=2;if(g>80) {g=68;new_key|=GP2X_LEFT;}}
		}
	if(old_key  & GP2X_RIGHT)
		{
		if(g==0) g=1;
		else if(!(g & 1)) g=1;
		else {g+=2;if(g>81) {g=69;new_key|=GP2X_RIGHT;}}
		}
	if(new_key & GP2X_LEFT) {keypos--;if(keypos<0) keypos=9;}
    if(new_key & GP2X_RIGHT) {keypos++;if(keypos>9) keypos=0;}
	if(new_key & GP2X_UP) {pos=0;op2--;if(op2<0) op2=9;}
    if(new_key & GP2X_DOWN) {pos=0;op2++;if(op2>9) op2=0;}

	if(new_key & GP2X_L) {pos--;if(pos<0) {pos=7;op2--;} if (op2<0) op2=0;}
    if(new_key & GP2X_R) {pos++;if(pos>7) {pos=0;op2++;} if (op2>9) op2=0;}
    if(new_key & (GP2X_X))
		{
		if(pos<5)
			{
			file_modified=1;
			change_digit1(&poke_table[poke_select][op2][0],num_key[keypos][0],pos);

			}
			else
			{
			file_modified=1;
			change_digit2(&poke_table[poke_select][op2][1],num_key[keypos][0],pos-5);

			}
			pos++;if(pos>7) {pos=0;op2++;} if (op2>9) op2=0;

		}
	}
}

if(file_modified) 
	write_pokefile(photo_name);

while(gp2x_nKeys & (GP2X_Y | GP2X_X | GP2X_START | GP2X_SELECT)) gp2x_nKeys=gp2x_joystick_poll();


COLORFONDO=0;
ClearScreen(COLORFONDO);gp2x_waitvsync();


return ret;
}
 
